#include<sys/select.h>
#include<cstdlib>
#include<cmath>
#include<cassert>

#include "wait.hh"

std::pair<bool, bool> waitBySelect(int fileDescriptor, double deadline) {
	struct timeval tv;
	tv.tv_sec = static_cast<long>(trunc(deadline));
	tv.tv_usec = static_cast<long>(trunc(((deadline) - trunc(deadline)) * 1000000));
	fd_set read_fs, except_fs;
	FD_ZERO(&read_fs);
	FD_ZERO(&except_fs);
	FD_SET(fileDescriptor, &read_fs);
	FD_SET(fileDescriptor, &except_fs);
	select(fileDescriptor + 1, &read_fs, NULL, &except_fs, &tv);
	return std::pair<bool, bool>(FD_ISSET(fileDescriptor, &read_fs), FD_ISSET(fileDescriptor, &except_fs));
}

bool waitBySelect(int fileDescriptor) {
	fd_set read_fs, except_fs;
	FD_ZERO(&read_fs);
	FD_ZERO(&except_fs);
	FD_SET(fileDescriptor, &read_fs);
	FD_SET(fileDescriptor, &except_fs);
	if (select(fileDescriptor + 1, &read_fs, NULL, &except_fs, NULL) == 1) return true;
	return false;
}

